package com.galaxis.wms.utils;

import org.w3c.dom.Document;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.xpath.XPath;
import javax.xml.xpath.XPathConstants;
import javax.xml.xpath.XPathFactory;
import java.io.ByteArrayInputStream;
import java.nio.charset.StandardCharsets;

/**
 * 作者：lizw <br/>
 * 创建时间：2022/03/17 11:08 <br/>
 */
public class XPathUtils {
    private static final DocumentBuilderFactory DOCUMENT_BUILDER_FACTORY = DocumentBuilderFactory.newInstance();
    private static final XPathFactory X_PATH_FACTORY = XPathFactory.newInstance();

    static {
        DOCUMENT_BUILDER_FACTORY.setValidating(false);
        DOCUMENT_BUILDER_FACTORY.setIgnoringComments(true);
        DOCUMENT_BUILDER_FACTORY.setIgnoringElementContentWhitespace(true);
    }

    public static String evaluate(String xml, String expression) throws Exception {
        DocumentBuilder documentBuilder = DOCUMENT_BUILDER_FACTORY.newDocumentBuilder();
        XPath xPath = X_PATH_FACTORY.newXPath();
        try (ByteArrayInputStream inputStream = new ByteArrayInputStream(xml.getBytes(StandardCharsets.UTF_8))) {
            Document document = documentBuilder.parse(inputStream);
            Object res = xPath.evaluate(expression, document, XPathConstants.STRING);
            if (res == null) {
                return null;
            }
            return String.valueOf(res);
        }
    }
}
